import {
  text_style_css_default
} from "./chunk.6OEWQFQM.js";
import {
  styleExpressionProperty
} from "./chunk.ADPMTWTS.js";
import {
  tokens
} from "./chunk.4YC6LR4Q.js";
import {
  GdsElement
} from "./chunk.ZQ4D5K7J.js";
import {
  gdsCustomElement
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/content/text/text.ts
import { html, unsafeStatic } from "lit/static-html.js";
import { property } from "lit/decorators.js";
var GdsText = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.tag = "span";
  }
  render() {
    const TAG_ENCODE = encodeURI(this.tag);
    const TAG = unsafeStatic(TAG_ENCODE);
    return html`<${TAG} tag><slot></slot></${TAG}>`;
  }
};
GdsText.styles = [tokens, text_style_css_default];
__decorateClass([
  property({ type: String })
], GdsText.prototype, "tag", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `${v}`,
    selector: "[tag]",
    styleTemplate: (prop, values) => {
      const size = values[0];
      const styleSize = `font-size: var(--gds-text-size-${size});`;
      const styleLine = `line-height: var(--gds-text-line-height-${size});`;
      return styleSize + styleLine;
    }
  })
], GdsText.prototype, "size", 2);
__decorateClass([
  styleExpressionProperty({
    property: "font-weight",
    selector: "[tag]",
    valueTemplate: (v) => `var(--gds-text-weight-${v})`
  })
], GdsText.prototype, "weight", 2);
__decorateClass([
  styleExpressionProperty({
    property: "margin",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "margin", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-wrap",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "wrap", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-transform",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "transform", 2);
__decorateClass([
  styleExpressionProperty({
    property: "max-width",
    selector: "[tag]",
    valueTemplate: (v) => `${v}ch`
  })
], GdsText.prototype, "length", 2);
__decorateClass([
  styleExpressionProperty({
    property: "min-width",
    selector: "[tag]",
    valueTemplate: (v) => `${v}ch`
  })
], GdsText.prototype, "min", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-align",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "align", 2);
__decorateClass([
  styleExpressionProperty({
    property: "--_lines",
    selector: "[tag]",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "lines", 2);
__decorateClass([
  styleExpressionProperty({
    property: "color",
    selector: "[tag]",
    valueTemplate: (v) => {
      const [colorName, transparency] = v.split("/");
      if (transparency) {
        return `color-mix(in srgb, var(--gds-sys-color-${colorName}) ${parseFloat(transparency) * 100}%, transparent 0%)`;
      } else {
        return `var(--gds-sys-color-${colorName})`;
      }
    }
  })
], GdsText.prototype, "color", 2);
GdsText = __decorateClass([
  gdsCustomElement("gds-text")
], GdsText);

export {
  GdsText
};
